package com.engine.jucailinkq.attendance.component.persongroup.web;

import com.engine.jucailinkq.attendance.component.persongroup.commonutil.PersongroupCommonUtil;
import com.engine.jucailinkq.attendance.component.persongroup.service.SchedulingResultsService;
import com.engine.jucailinkq.attendance.component.persongroup.service.impl.SchedulingResultsServiceImpl;
import com.engine.jucailinkq.common.util.ApiReturnTools;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import lombok.extern.slf4j.Slf4j;
import weaver.general.Util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import java.util.List;
import java.util.Map;
@Slf4j
public class SchedulingResultsAction {

    private SchedulingResultsService basicsetService = ServiceUtil.getService(SchedulingResultsServiceImpl.class);
    /**
     * 获得排班结果列表查询
     * @return
     */
    @POST
    @Path("/getSchedulingData")
    @Produces({"text/plain"})
    public String getSchedulingData(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            Map<String,Object> paramMap = ParamUtil.request2Map(request);
            Map<String,Object> dataMap = basicsetService.queryDataTable(paramMap);
            List<Map<String,Object>> dataTable = (List<Map<String,Object>>)dataMap.get("data");
            Map<String,Object> personGroupMap = PersongroupCommonUtil.getPersonGroup();
            Map<String,Object> departMentMap = PersongroupCommonUtil.getDepartMent();
            Map<String,Object> subCompanyMap = PersongroupCommonUtil.getSubCompany();
            Map<String,Object> classesInformationMap = PersongroupCommonUtil.getClassesInformation();
            Map<String,Object> candidateTeamMap = PersongroupCommonUtil.getCandidateTeam();
            Map<String,Object> personName = PersongroupCommonUtil.getPersonName();
            for (Map<String,Object> map :dataTable){
                String dxlx = Util.null2String(map.get("dxlx"));
                if (dxlx.equals("0")){
                    //人员
                    String pbdxry = Util.null2String(map.get("pbdxry"));
                    String lastname = Util.null2String(personName.get(pbdxry));
                    pbdxry = pbdxry +"-"+lastname;
                    map.put("pbdxry",pbdxry);

                }else if (dxlx.equals("1")){
                    //人员分组
                    String pbdxryfz = Util.null2String(map.get("pbdxryfz"));
                    pbdxryfz= pbdxryfz+"-"+personGroupMap.get(pbdxryfz);
                    map.put("pbdxryfz",pbdxryfz);

                }else if (dxlx.equals("2")){
                    //部门
                    String pbdxbm = Util.null2String(map.get("pbdxbm"));
                    pbdxbm= pbdxbm+"-"+departMentMap.get(pbdxbm);
                    map.put("pbdxbm",pbdxbm);

                }else if (dxlx.equals("3")){
                    //分部
                    String pbdxfb = Util.null2String(map.get("pbdxfb"));
                    pbdxfb= pbdxfb+"-"+subCompanyMap.get(pbdxfb);
                    map.put("pbdxfb",pbdxfb);
                }
                String bcxx = Util.null2String(map.get("bcxx"));
                String hxbz = Util.null2String(map.get("hxbz"));
                if (!"".equals(bcxx)){
                    bcxx = bcxx +"-"+classesInformationMap.get(bcxx);
                    map.put("bcxx",bcxx);
                }
                if (!"".equals(hxbz)){
                    hxbz = hxbz +"-"+candidateTeamMap.get(hxbz);
                    map.put("hxbz",hxbz);
                }

            }

            return ApiReturnTools.success(dataMap);
        }catch (Exception e){
            log.error("execute fail,catch error: [{}]",e);
            return ApiReturnTools.error("500","saveApplicableOrganization error");
        }
    }
    /**
     * 出勤结果更改时插入排班结果
     * @return
     */
    @POST
    @Path("/saveScheduleResult")
    @Produces({"text/plain"})
    public String saveScheduleResult(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            Map<String,Object> paramMap = ParamUtil.request2Map(request);
            Map<String,Object> dataMap = basicsetService.saveScheduleResult(paramMap);
            return ApiReturnTools.success(dataMap);
        }catch (Exception e){
            log.error("execute fail,catch error: [{}]",e);
            return ApiReturnTools.error("500","saveApplicableOrganization error");
        }
    }

    /**
     * 生成排班结果
     * @return
     */
    @POST
    @Path("/generateSchedule")
    @Produces({"text/plain"})
    public String generateSchedule(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            Map<String,Object> paramMap = ParamUtil.request2Map(request);
            Map<String,Object> dataMap = basicsetService.generateSchedule(paramMap);
            return ApiReturnTools.success(dataMap);
        }catch (Exception e){
            log.error("execute fail,catch error: [{}]",e);
            return ApiReturnTools.error("500","generateSchedule error");
        }
    }
    /**
     * 批量删除排班结果
     * @return
     */
    @POST
    @Path("/deleteBatchSchedule")
    @Produces({"text/plain"})
    public String deleteBatchSchedule(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        try {
            Map<String,Object> paramMap = ParamUtil.request2Map(request);
            Map<String,Object> dataMap = basicsetService.deleteBatchSchedule(paramMap);
            return ApiReturnTools.success(dataMap);
        }catch (Exception e){
            log.error("execute fail,catch error: [{}]",e);
            return ApiReturnTools.error("500","generateSchedule error");
        }
    }

}
